<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'BySolutionValueProp',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    justifyContent: {
      type: Boolean,
      required: false,
      default: false,
    },
    offset: {
      type: Number,
      required: false,
      default: 0,
    },
  },
});
</script>

<template>
  <section class="solution-value-prop">
    <SlpContainer>
      <SlpRow class="resources-block-container">
        <SlpColumn v-if="offset !== 0" :cols="offset" />
        <SlpColumn v-if="justifyContent" :cols="2" />
        <SlpColumn
          :cols="7"
          class="resources-block__header"
          :data-aos="data.header_animation"
          :data-aos-duration="data.header_animation_duration"
        >
          <SlpTypography tag="h2" variant="heading3" class="slp-mt-32 slp-mb-64"
            >{{ data.title }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
      <SlpRow>
        <SlpColumn v-if="offset !== 0" :cols="offset" />
        <SlpColumn v-if="justifyContent" :cols="2" />
        <SlpColumn>
          <SlpRow
            :style="{
              justifyContent: justifyContent ? 'flex-end' : 'flex-start',
            }"
          >
            <SlpColumn
              v-for="(card, index) in data.cards"
              :key="index"
              :cols="
                data.cards.length % 2 !== 0 && index + 1 === data.cards.length
                  ? 12
                  : 6
              "
              :data-aos="data.cards_animation"
              :data-aos-duration="data.cards_animation_duration"
              size="md"
              class="resources-block__col"
            >
              <div class="resources-block">
                <div class="resources-block__wrapper">
                  <div class="resources-block__content-top">
                    <div class="resources-block__category slp-flex">
                      <SlpIcon
                        v-if="card.icon"
                        :name="card.icon.name"
                        :alt="card.icon.alt"
                        :variant="card.icon.variant"
                        size="md"
                      />
                      <SlpTypography tag="p" variant="all-caps"
                        >{{ card.category }}
                      </SlpTypography>
                    </div>
                    <SlpTypography
                      tag="h3"
                      variant="heading4"
                      class="resources-block__title"
                      >{{ card.title }}
                    </SlpTypography>
                    <SlpTypography
                      tag="p"
                      variant="body1"
                      class="resources-block__description"
                      ><span v-html="card.description"></span>
                    </SlpTypography>
                    <SlpButton
                      v-if="card.href"
                      variant="tertiary"
                      class="learn-more"
                      :href="card.href"
                      >Learn More

                      <SlpIcon name="chevron-lg-right" variant="product" />
                    </SlpButton>
                    <SlpTypography
                      tag="p"
                      variant="body1"
                      class="resources-block__description"
                    >
                      <ul v-if="card.list" class="resources-block__list">
                        <li
                          v-for="feature in card.list"
                          :key="feature.text"
                          class="item"
                        >
                          <SlpIcon
                            name="check"
                            class="bullet"
                            variant="product"
                            alt="Check icon"
                            size="sm"
                          />
                          <span
                            class="slp-text-body1"
                            v-html="feature.text"
                          ></span>
                        </li>
                      </ul>
                    </SlpTypography>
                  </div>
                </div>
              </div>
            </SlpColumn>
          </SlpRow>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.solution-value-prop {
  background-color: $color-surface-800;
  padding-top: 96px;
  padding-bottom: $spacing-96;
  .learn-more {
    padding-left: 0;
    margin-top: auto;
  }
  @media (max-width: $breakpoint-md) {
    padding: $spacing-48 0;
  }

  h2 {
    font-size: $text-heading-2;
    line-height: $line-height-heading-2;
    font-weight: $font-weight-bold;
  }

  .resources-block {
    //cursor: pointer;
    display: flex;
    position: relative;
    height: 100%;

    &__wrapper {
      display: flex;
      flex-direction: column;
      transition: all 0.3s ease-in-out;
      justify-content: space-between;
      padding: $spacing-32;
      background: $color-primary-300;
      flex: 1;
      border-radius: $spacing-4;
      @media (min-width: $breakpoint-md) {
        margin: $spacing-8 $spacing-16 $spacing-8 0;
      }
      @media (max-width: $breakpoint-md) {
        margin: $spacing-8 0;
      }

      // This creates the rounded corner hover effect if card is clickable
      //&:hover {
      //  background: $color-surface-900;
      //  border-bottom-right-radius: 100px;
      //  box-shadow: 10px 10px 40px 10px #d1d0d3;
      //}
    }

    &__header {
      width: 100%;
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
    }

    &__category {
      margin-bottom: $spacing-24;

      img {
        max-width: 30px;
        filter: grayscale(100%);
        -webkit-filter: grayscale(100%);
      }

      p {
        margin-left: $spacing-16;
        text-transform: uppercase;
        font-weight: $font-weight-bold;
        letter-spacing: 1px;
      }
    }

    &__image {
      max-width: 100%;
    }

    &__link {
      color: $color-text-300;
      padding-left: 0;
    }

    &__title {
      margin-bottom: $spacing-16;
      font-size: $text-heading-4;
      font-weight: $font-weight-bold;
    }

    &__description {
      margin-bottom: $spacing-16;

      // Why doesn't this work!!??
      a:hover {
        text-decoration: underline;
      }
    }

    &__list {
      margin-bottom: $spacing-16;

      .item {
        margin-bottom: $spacing-16;
        display: flex;
      }

      .bullet {
        margin-right: $spacing-8;
      }
    }

    &__content-top {
      display: flex;
      flex-basis: 100%;
      flex-direction: column;
      p,
      h3,
      li {
        color: $color-text-300;
      }

      :last-child {
        margin-bottom: 0;
      }
    }
    &__col {
      width: 100%;
    }
  }
}
</style>
